$(() => {
const taskItem = (task) => {
const className = `task-item task-item-priority-${task.priority}`;
return `
<div class="${className}">
<span class="task-item-text">
${task.text}
</span>
<span class="task-item-info">
${task.date} by ${task.assignedBy}
</span>
<i class="task-item-pseudo-button dx-icon dx-icon-overflow"></i>
</div>
`;
};
const taskList = (tasks) => {
const list = tasks.reduce((accumulator, task) => `${accumulator} ${taskItem(task)}`, '');
return `
<div class="tabpanel-item">
${list}
</div>
`;
};
const tabPanel = $('#tabpanel').dxTabPanel({
dataSource,
width: '100%',
height: 418,
animationEnabled: true,
swipeEnabled: true,
tabsPosition: tabsPositions[0],
stylingMode: stylingModes[0],
iconPosition: iconPositions[0],
itemTemplate: ({ tasks }) => taskList(tasks),
}).dxTabPanel('instance');
$('#tabs-position-selectbox').dxSelectBox({
inputAttr: tabsPositionsSelectBoxLabel,
items: tabsPositions,
value: tabsPositions[0],
onValueChanged({ value }) {
tabPanel.option({ tabsPosition: value });
},
});
$('#styling-mode-selectbox').dxSelectBox({
inputAttr: stylingModesSelectBoxLabel,
items: stylingModes,
value: stylingModes[0],
onValueChanged({ value }) {
tabPanel.option({ stylingMode: value });
},
});
$('#icon-position-selectbox').dxSelectBox({
inputAttr: iconPositionsSelectBoxLabel,
items: iconPositions,
value: iconPositions[0],
onValueChanged({ value }) {
tabPanel.option({ iconPosition: value });
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="tabpanel-demo">
<div class="widget-container">
<div id="tabpanel"></div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div class="option-label">Tab position</div>
<div id="tabs-position-selectbox"></div>
</div>
<div class="option">
<div class="option-label">Styling mode</div>
<div id="styling-mode-selectbox"></div>
</div>
<div class="option">
<div class="option-label">Icon position</div>
<div id="icon-position-selectbox"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.tabpanel-demo {
display: flex;
height: 100%;
}
.widget-container {
display: flex;
justify-content: center;
flex-grow: 1;
min-width: 360px;
padding: 16px 32px;
}
.tabpanel-demo .dx-tabpanel {
background-color: var(--dx-component-color-bg);
}
.dx-theme-material .widget-container {
background-color: rgba(191, 191, 191, 0.15);
}
.dx-tabpanel-tabs-position-left .dx-tabpanel-container,
.dx-tabpanel-tabs-position-right .dx-tabpanel-container {
width: 0;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabpanel {
border-radius: 8px;
overflow: clip;
}
.dx-tabs-vertical {
min-width: 120px;
}
.options {
display: inline-flex;
flex-direction: column;
flex-shrink: 0;
box-sizing: border-box;
width: 272px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 20px;
}
.tabpanel-item {
display: flex;
flex-direction: column;
gap: 12px;
padding: 24px;
}
.task-item {
position: relative;
display: flex;
flex-direction: column;
justify-content: center;
width: 100%;
height: 50px;
padding: 8px 12px 8px 8px;
border-radius: 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.15);
}
.task-item::before {
content: "";
position: absolute;
top: 8px;
left: 6px;
bottom: 8px;
width: 3px;
border-radius: 4px;
}
.task-item-priority-high::before {
background-color: #e1bee7;
}
.task-item-priority-medium::before {
background-color: #ffe0b2;
}
.task-item-priority-low::before {
background-color: #c8e6c9;
}
.task-item-text,
.task-item-info {
margin: 0;
padding: 0 24px 0 16px;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
}
.task-item-info {
font-size: 12px;
opacity: 0.6;
}
.task-item-pseudo-button {
position: absolute;
right: 8px;
top: 50%;
font-size: 18px;
transform: translateY(-50%);
cursor: pointer;
opacity: 0.6;
}
.dx-color-scheme-contrast .task-item {
border: 1px solid #fff;
}
.dx-theme-fluent.dx-color-scheme-blue-dark .task-item {
background-color: #1f1f1f;
}
const tabsPositionsSelectBoxLabel = { 'aria-label': 'Tab position' };
const tabsPositions = [
'left',
'top',
'right',
'bottom',
];
const stylingModesSelectBoxLabel = { 'aria-label': 'Styling mode' };
const stylingModes = [
'secondary',
'primary',
];
const iconPositionsSelectBoxLabel = { 'aria-label': 'Icon positions' };
const iconPositions = [
'top',
'start',
'end',
'bottom',
];
const tasks = [
{
status: 'Not Started',
priority: 'high',
text: 'Revenue Projections',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Not Started',
priority: 'high',
text: 'New Brochures',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Not Started',
priority: 'medium',
text: 'Training',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Not Started',
priority: 'medium',
text: 'NDA',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Not Started',
priority: 'low',
text: 'Health Insurance',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Help Needed',
priority: 'low',
text: 'TV Recall',
date: '2023/09/16',
assignedBy: 'Brett Wade',
},
{
status: 'Help Needed',
priority: 'low',
text: 'Recall and Refund Forms',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Help Needed',
priority: 'high',
text: 'Shippers',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Help Needed',
priority: 'medium',
text: 'Hardware Upgrade',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Online Sales',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'In Progress',
priority: 'medium',
text: 'New Website Design',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'In Progress',
priority: 'low',
text: 'Bandwidth Increase',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Support',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'In Progress',
priority: 'low',
text: 'Training Material',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Deferred',
priority: 'medium',
text: 'New Database',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Deferred',
priority: 'high',
text: 'Automation Server',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Retail Sales',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Shipping Labels',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Rejected',
priority: 'high',
text: 'Schedule Meeting with Sales Team',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Confirm Availability for Sales Meeting',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Reschedule Sales Team Meeting',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'Rejected',
priority: 'high',
text: 'Update Database with New Leads',
date: '2023/09/16',
assignedBy: 'Kevin Carter',
},
{
status: 'Rejected',
priority: 'low',
text: 'Send Territory Sales Breakdown',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'Completed',
priority: 'medium',
text: 'Territory Sales Breakdown Report',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'Completed',
priority: 'low',
text: 'Return Merchandise Report',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'Completed',
priority: 'high',
text: 'Staff Productivity Report',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'Completed',
priority: 'medium',
text: 'Review HR Budget Company Wide',
date: '2023/09/16',
assignedBy: 'Mary Stern',
},
];
const dataSource = [
{
icon: 'description',
title: 'Not Started',
tasks: tasks.filter((item) => item.status === 'Not Started'),
},
{
icon: 'taskhelpneeded',
title: 'Help Needed',
tasks: tasks.filter((item) => item.status === 'Help Needed'),
},
{
icon: 'taskinprogress',
title: 'In Progress',
tasks: tasks.filter((item) => item.status === 'In Progress'),
},
{
icon: 'taskstop',
title: 'Deferred',
tasks: tasks.filter((item) => item.status === 'Deferred'),
},
{
icon: 'taskrejected',
title: 'Rejected',
tasks: tasks.filter((item) => item.status === 'Rejected'),
},
{
icon: 'taskcomplete',
title: 'Completed',
tasks: tasks.filter((item) => item.status === 'Completed'),
},
];

<div class="tabpanel-demo">
<div class="widget-container">
<dx-tab-panel
width="100%"
[height]="418"
[animationEnabled]="true"
[swipeEnabled]="true"
[dataSource]="dataSource"
[tabsPosition]="tabsPosition"
[stylingMode]="stylingMode"
[iconPosition]="iconPosition"
>
<div *dxTemplate="let tabPanelItem of 'item'">
<div class="tabpanel-item">
@for (task of tabPanelItem.tasks; track task.text) {
<div [class]="getTaskItemClasses(task.priority)">
<span class="task-item-text">
{{ task.text }}
</span>
<span class="task-item-info">
{{ task.date }} by {{ task.assignedBy }}
</span>
<i class="task-item-pseudo-button dx-icon dx-icon-overflow"></i>
</div>
}
</div>
</div>
</dx-tab-panel>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div class="option-label">Tab position</div>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Tab position' }"
[items]="tabsPositions"
[(value)]="tabsPosition"
></dx-select-box>
</div>
<div class="option">
<div class="option-label">Styling mode</div>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Styling mode' }"
[items]="stylingModes"
[(value)]="stylingMode"
></dx-select-box>
</div>
<div class="option">
<div class="option-label">Icon position</div>
<dx-select-box
[inputAttr]="{ 'aria-label': 'Icon positions' }"
[items]="iconPositions"
[(value)]="iconPosition"
></dx-select-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxTabPanelModule, DxCheckBoxModule, DxSelectBoxModule,
} from 'devextreme-angular';
import type { DxTabPanelTypes } from 'devextreme-angular/ui/tab-panel';
import { TabPanelItem, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxTabPanelModule,
DxCheckBoxModule,
DxSelectBoxModule,
],
})
export class AppComponent {
dataSource: TabPanelItem[];
tabsPositions: DxTabPanelTypes.Position[] = [
'left', 'top', 'right', 'bottom',
];
tabsPosition: DxTabPanelTypes.Position = this.tabsPositions[0];
stylingModes: DxTabPanelTypes.TabsStyle[] = ['secondary', 'primary'];
stylingMode: DxTabPanelTypes.TabsStyle = this.stylingModes[0];
iconPositions: DxTabPanelTypes.TabsIconPosition[] = [
'top', 'start', 'end', 'bottom',
];
iconPosition: DxTabPanelTypes.TabsIconPosition = this.iconPositions[0];
constructor(service: Service) {
this.dataSource = service.getItems();
}
getTaskItemClasses(priority: string) {
return `task-item task-item-priority-${priority}`;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .tabpanel-demo {
display: flex;
height: 100%;
}
::ng-deep .widget-container {
display: flex;
justify-content: center;
flex-grow: 1;
min-width: 360px;
padding: 16px 32px;
}
::ng-deep .tabpanel-demo .dx-tabpanel {
background-color: var(--dx-component-color-bg);
}
::ng-deep .dx-theme-material .widget-container {
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .dx-tabpanel-tabs-position-left .dx-tabpanel-container,
::ng-deep .dx-tabpanel-tabs-position-right .dx-tabpanel-container {
width: 0;
}
::ng-deep .dx-viewport:not(.dx-theme-generic) .dx-tabpanel {
border-radius: 8px;
overflow: clip;
}
::ng-deep .dx-tabs-vertical {
min-width: 120px;
}
.options {
display: inline-flex;
flex-direction: column;
flex-shrink: 0;
box-sizing: border-box;
width: 272px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 20px;
}
::ng-deep .tabpanel-item {
display: flex;
flex-direction: column;
gap: 12px;
padding: 24px;
}
::ng-deep .task-item {
position: relative;
display: flex;
flex-direction: column;
justify-content: center;
width: 100%;
height: 50px;
padding: 8px 12px 8px 8px;
border-radius: 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.15);
}
::ng-deep .task-item::before {
content: "";
position: absolute;
top: 8px;
left: 6px;
bottom: 8px;
width: 3px;
border-radius: 4px;
}
::ng-deep .task-item-priority-high::before {
background-color: #e1bee7;
}
::ng-deep .task-item-priority-medium::before {
background-color: #ffe0b2;
}
::ng-deep .task-item-priority-low::before {
background-color: #c8e6c9;
}
::ng-deep .task-item-text,
::ng-deep .task-item-info {
margin: 0;
padding: 0 24px 0 16px;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
}
::ng-deep .task-item-info {
font-size: 12px;
opacity: 0.6;
}
::ng-deep .task-item-pseudo-button {
position: absolute;
right: 8px;
top: 50%;
font-size: 18px;
transform: translateY(-50%);
cursor: pointer;
opacity: 0.6;
}
::ng-deep .dx-color-scheme-contrast .task-item {
border: 1px solid #fff;
}
::ng-deep .dx-theme-fluent.dx-color-scheme-blue-dark .task-item {
background-color: #1f1f1f;
}
import { Injectable } from '@angular/core';
export class Task {
status: string;
priority: string;
text: string;
date: string;
assignedBy: string;
}
export class TabPanelItem {
icon: string;
title: string;
tasks: Task[];
}
const tasks: Task[] = [
{
status: 'Not Started',
priority: 'high',
text: 'Revenue Projections',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Not Started',
priority: 'high',
text: 'New Brochures',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Not Started',
priority: 'medium',
text: 'Training',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Not Started',
priority: 'medium',
text: 'NDA',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Not Started',
priority: 'low',
text: 'Health Insurance',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Help Needed',
priority: 'low',
text: 'TV Recall',
date: '2023/09/16',
assignedBy: 'Brett Wade',
},
{
status: 'Help Needed',
priority: 'low',
text: 'Recall and Refund Forms',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Help Needed',
priority: 'high',
text: 'Shippers',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Help Needed',
priority: 'medium',
text: 'Hardware Upgrade',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Online Sales',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'In Progress',
priority: 'medium',
text: 'New Website Design',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'In Progress',
priority: 'low',
text: 'Bandwidth Increase',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Support',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'In Progress',
priority: 'low',
text: 'Training Material',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Deferred',
priority: 'medium',
text: 'New Database',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Deferred',
priority: 'high',
text: 'Automation Server',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Retail Sales',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Shipping Labels',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Rejected',
priority: 'high',
text: 'Schedule Meeting with Sales Team',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Confirm Availability for Sales Meeting',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Reschedule Sales Team Meeting',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'Rejected',
priority: 'high',
text: 'Update Database with New Leads',
date: '2023/09/16',
assignedBy: 'Kevin Carter',
},
{
status: 'Rejected',
priority: 'low',
text: 'Send Territory Sales Breakdown',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'Completed',
priority: 'medium',
text: 'Territory Sales Breakdown Report',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'Completed',
priority: 'low',
text: 'Return Merchandise Report',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'Completed',
priority: 'high',
text: 'Staff Productivity Report',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'Completed',
priority: 'medium',
text: 'Review HR Budget Company Wide',
date: '2023/09/16',
assignedBy: 'Mary Stern',
},
];
export const dataSource: TabPanelItem[] = [
{
icon: 'description',
title: 'Not Started',
tasks: tasks.filter((item) => item.status === 'Not Started'),
},
{
icon: 'taskhelpneeded',
title: 'Help Needed',
tasks: tasks.filter((item) => item.status === 'Help Needed'),
},
{
icon: 'taskinprogress',
title: 'In Progress',
tasks: tasks.filter((item) => item.status === 'In Progress'),
},
{
icon: 'taskstop',
title: 'Deferred',
tasks: tasks.filter((item) => item.status === 'Deferred'),
},
{
icon: 'taskrejected',
title: 'Rejected',
tasks: tasks.filter((item) => item.status === 'Rejected'),
},
{
icon: 'taskcomplete',
title: 'Completed',
tasks: tasks.filter((item) => item.status === 'Completed'),
},
];
@Injectable()
export class Service {
getItems(): TabPanelItem[] {
return dataSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div class="tabpanel-demo">
<div class="widget-container">
<DxTabPanel
width="100%"
height="418"
item-template="tabPanelItem"
:animation-enabled="true"
:swipe-enabled="true"
:data-source="dataSource"
:tabs-position="tabsPosition"
:styling-mode="stylingMode"
:icon-position="iconPosition"
>
<template #tabPanelItem="{ data }">
<TabPanelItem
:tasks="data.tasks"
/>
</template>
</DxTabPanel>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div class="option-label">Tab position</div>
<DxSelectBox
v-model:value="tabsPosition"
:input-attr="tabsPositionsSelectBoxLabel"
:items="tabsPositions"
/>
</div>
<div class="option">
<div class="option-label">Styling mode</div>
<DxSelectBox
v-model:value="stylingMode"
:input-attr="stylingModesSelectBoxLabel"
:items="stylingModes"
/>
</div>
<div class="option">
<div class="option-label">Icon position</div>
<DxSelectBox
v-model:value="iconPosition"
:input-attr="iconPositionsSelectBoxLabel"
:items="iconPositions"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxTabPanel from 'devextreme-vue/tab-panel';
import DxSelectBox from 'devextreme-vue/select-box';
import TabPanelItem from './TabPanelItem.vue';
import {
tabsPositionsSelectBoxLabel,
tabsPositions,
stylingModesSelectBoxLabel,
stylingModes,
iconPositionsSelectBoxLabel,
iconPositions,
dataSource,
} from './data.ts';
const tabsPosition = ref(tabsPositions[0]);
const stylingMode = ref(stylingModes[0]);
const iconPosition = ref(iconPositions[0]);
</script>
<style>
.tabpanel-demo {
display: flex;
height: 100%;
}
.widget-container {
display: flex;
justify-content: center;
flex-grow: 1;
min-width: 360px;
padding: 16px 32px;
}
.tabpanel-demo .dx-tabpanel {
background-color: var(--dx-component-color-bg);
}
.dx-theme-material .widget-container {
background-color: rgba(191, 191, 191, 0.15);
}
.dx-tabpanel-tabs-position-left .dx-tabpanel-container,
.dx-tabpanel-tabs-position-right .dx-tabpanel-container {
width: 0;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabpanel {
border-radius: 8px;
overflow: clip;
}
.dx-tabs-vertical {
min-width: 120px;
}
.options {
display: inline-flex;
flex-direction: column;
flex-shrink: 0;
box-sizing: border-box;
width: 272px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 20px;
}
</style>
<template>
<div>
<div class="tabpanel-item">
<TaskItem
v-for="(task, index) in tasks"
:key="index"
:task="task"
/>
</div>
</div>
</template>
<script setup lang="ts">
import TaskItem from './TaskItem.vue';
withDefaults(defineProps<{
tasks?: Record<string, any>[]
}>(), {
tasks: () => [],
});
</script>
<style>
.tabpanel-item {
display: flex;
flex-direction: column;
gap: 12px;
padding: 24px;
}
</style>
<template>
<div :class="['task-item', `task-item-priority-${task.priority}`]">
<span class="task-item-text">
{{ task.text }}
</span>
<span class="task-item-info">
{{ task.date }} by {{ task.assignedBy }}
</span>
<i class="task-item-pseudo-button dx-icon dx-icon-overflow"/>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
task?: Record<string, any>
}>(), {
task: () => ({} as Record<string, any>),
});
</script>
<style>
.task-item {
position: relative;
display: flex;
flex-direction: column;
justify-content: center;
width: 100%;
height: 50px;
padding: 8px 12px 8px 8px;
border-radius: 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.15);
}
.task-item::before {
content: "";
position: absolute;
top: 8px;
left: 6px;
bottom: 8px;
width: 3px;
border-radius: 4px;
}
.task-item-priority-high::before {
background-color: #e1bee7;
}
.task-item-priority-medium::before {
background-color: #ffe0b2;
}
.task-item-priority-low::before {
background-color: #c8e6c9;
}
.task-item-text,
.task-item-info {
margin: 0;
padding: 0 24px 0 16px;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
}
.task-item-info {
font-size: 12px;
opacity: 0.6;
}
.task-item-pseudo-button {
position: absolute;
right: 8px;
top: 50%;
font-size: 18px;
transform: translateY(-50%);
cursor: pointer;
opacity: 0.6;
}
.dx-color-scheme-contrast .task-item {
border: 1px solid #fff;
}
.dx-theme-fluent.dx-color-scheme-blue-dark .task-item {
background-color: #1f1f1f;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { type Position } from 'devextreme/common';
import { type DxTabPanelTypes } from 'devextreme-vue/tab-panel';
export const tabsPositionsSelectBoxLabel = { 'aria-label': 'Tab position' };
export const tabsPositions: Position[] = [
'left',
'top',
'right',
'bottom',
];
export const stylingModesSelectBoxLabel = { 'aria-label': 'Styling mode' };
export const stylingModes: DxTabPanelTypes.TabsStyle[] = [
'secondary',
'primary',
];
export const iconPositionsSelectBoxLabel = { 'aria-label': 'Icon positions' };
export const iconPositions: DxTabPanelTypes.TabsIconPosition[] = [
'top',
'start',
'end',
'bottom',
];
const tasks = [
{
status: 'Not Started',
priority: 'high',
text: 'Revenue Projections',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Not Started',
priority: 'high',
text: 'New Brochures',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Not Started',
priority: 'medium',
text: 'Training',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Not Started',
priority: 'medium',
text: 'NDA',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Not Started',
priority: 'low',
text: 'Health Insurance',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Help Needed',
priority: 'low',
text: 'TV Recall',
date: '2023/09/16',
assignedBy: 'Brett Wade',
},
{
status: 'Help Needed',
priority: 'low',
text: 'Recall and Refund Forms',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Help Needed',
priority: 'high',
text: 'Shippers',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Help Needed',
priority: 'medium',
text: 'Hardware Upgrade',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Online Sales',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'In Progress',
priority: 'medium',
text: 'New Website Design',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'In Progress',
priority: 'low',
text: 'Bandwidth Increase',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Support',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'In Progress',
priority: 'low',
text: 'Training Material',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Deferred',
priority: 'medium',
text: 'New Database',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Deferred',
priority: 'high',
text: 'Automation Server',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Retail Sales',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Shipping Labels',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Rejected',
priority: 'high',
text: 'Schedule Meeting with Sales Team',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Confirm Availability for Sales Meeting',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Reschedule Sales Team Meeting',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'Rejected',
priority: 'high',
text: 'Update Database with New Leads',
date: '2023/09/16',
assignedBy: 'Kevin Carter',
},
{
status: 'Rejected',
priority: 'low',
text: 'Send Territory Sales Breakdown',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'Completed',
priority: 'medium',
text: 'Territory Sales Breakdown Report',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'Completed',
priority: 'low',
text: 'Return Merchandise Report',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'Completed',
priority: 'high',
text: 'Staff Productivity Report',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'Completed',
priority: 'medium',
text: 'Review HR Budget Company Wide',
date: '2023/09/16',
assignedBy: 'Mary Stern',
},
];
export const dataSource = [
{
icon: 'description',
title: 'Not Started',
tasks: tasks.filter((item) => item.status === 'Not Started'),
},
{
icon: 'taskhelpneeded',
title: 'Help Needed',
tasks: tasks.filter((item) => item.status === 'Help Needed'),
},
{
icon: 'taskinprogress',
title: 'In Progress',
tasks: tasks.filter((item) => item.status === 'In Progress'),
},
{
icon: 'taskstop',
title: 'Deferred',
tasks: tasks.filter((item) => item.status === 'Deferred'),
},
{
icon: 'taskrejected',
title: 'Rejected',
tasks: tasks.filter((item) => item.status === 'Rejected'),
},
{
icon: 'taskcomplete',
title: 'Completed',
tasks: tasks.filter((item) => item.status === 'Completed'),
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React, { useCallback, useState } from 'react';
import SelectBox from 'devextreme-react/select-box';
import type { SelectBoxTypes } from 'devextreme-react/select-box';
import TabPanel from 'devextreme-react/tab-panel';
import type { Position, TabsIconPosition, TabsStyle } from 'devextreme/common';
import TabPanelItem from './TabPanelItem.tsx';
import {
tabsPositionsSelectBoxLabel,
tabsPositions,
stylingModesSelectBoxLabel,
stylingModes,
iconPositionsSelectBoxLabel,
iconPositions,
dataSource,
} from './data.ts';
const App = () => {
const [tabsPosition, setTabsPosition] = useState<Position>(tabsPositions[0]);
const [stylingMode, setStylingMode] = useState<TabsStyle>(stylingModes[0]);
const [iconPosition, setIconPosition] = useState<TabsIconPosition>(iconPositions[0]);
const onTabsPositionChanged = useCallback(({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setTabsPosition(value);
}, []);
const onStylingModeChanged = useCallback(({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setStylingMode(value);
}, []);
const onIconPositionChanged = useCallback(({ value }: SelectBoxTypes.ValueChangedEvent): void => {
setIconPosition(value);
}, []);
return (
<div className="tabpanel-demo">
<div className="widget-container">
<TabPanel
width="100%"
height={418}
animationEnabled={true}
swipeEnabled={true}
dataSource={dataSource}
tabsPosition={tabsPosition}
stylingMode={stylingMode}
iconPosition={iconPosition}
itemComponent={TabPanelItem}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div className="option-label">Tab position</div>
<SelectBox
inputAttr={tabsPositionsSelectBoxLabel}
items={tabsPositions}
value={tabsPosition}
onValueChanged={onTabsPositionChanged}
/>
</div>
<div className="option">
<div className="option-label">Styling mode</div>
<SelectBox
inputAttr={stylingModesSelectBoxLabel}
items={stylingModes}
value={stylingMode}
onValueChanged={onStylingModeChanged}
/>
</div>
<div className="option">
<div className="option-label">Icon position</div>
<SelectBox
inputAttr={iconPositionsSelectBoxLabel}
items={iconPositions}
value={iconPosition}
onValueChanged={onIconPositionChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import SelectBox from 'devextreme-react/select-box';
import TabPanel from 'devextreme-react/tab-panel';
import TabPanelItem from './TabPanelItem.js';
import {
tabsPositionsSelectBoxLabel,
tabsPositions,
stylingModesSelectBoxLabel,
stylingModes,
iconPositionsSelectBoxLabel,
iconPositions,
dataSource,
} from './data.js';
const App = () => {
const [tabsPosition, setTabsPosition] = useState(tabsPositions[0]);
const [stylingMode, setStylingMode] = useState(stylingModes[0]);
const [iconPosition, setIconPosition] = useState(iconPositions[0]);
const onTabsPositionChanged = useCallback(({ value }) => {
setTabsPosition(value);
}, []);
const onStylingModeChanged = useCallback(({ value }) => {
setStylingMode(value);
}, []);
const onIconPositionChanged = useCallback(({ value }) => {
setIconPosition(value);
}, []);
return (
<div className="tabpanel-demo">
<div className="widget-container">
<TabPanel
width="100%"
height={418}
animationEnabled={true}
swipeEnabled={true}
dataSource={dataSource}
tabsPosition={tabsPosition}
stylingMode={stylingMode}
iconPosition={iconPosition}
itemComponent={TabPanelItem}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div className="option-label">Tab position</div>
<SelectBox
inputAttr={tabsPositionsSelectBoxLabel}
items={tabsPositions}
value={tabsPosition}
onValueChanged={onTabsPositionChanged}
/>
</div>
<div className="option">
<div className="option-label">Styling mode</div>
<SelectBox
inputAttr={stylingModesSelectBoxLabel}
items={stylingModes}
value={stylingMode}
onValueChanged={onStylingModeChanged}
/>
</div>
<div className="option">
<div className="option-label">Icon position</div>
<SelectBox
inputAttr={iconPositionsSelectBoxLabel}
items={iconPositions}
value={iconPosition}
onValueChanged={onIconPositionChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import TaskItem from './TaskItem.tsx';
import type { Task } from './types.ts';
interface TabPanelItemProps {
data: {
tasks: Task[];
};
}
function TabPanelItem({ data }: TabPanelItemProps) {
const taskItems = data.tasks.map((task: Task, index: number) => <TaskItem key={index} task={task} />);
return (
<div className="tabpanel-item">
{taskItems}
</div>
);
}
export default TabPanelItem;
import React from 'react';
import type { Task } from './types.ts';
interface TaskItemProps {
task: Task;
}
function TaskItem({ task }: TaskItemProps) {
const {
priority,
text,
date,
assignedBy,
} = task;
return (
<div className={`task-item task-item-priority-${priority}`}>
<span className="task-item-text">
{text}
</span>
<span className="task-item-info">
{`${date} by ${assignedBy}`}
</span>
<i className="task-item-pseudo-button dx-icon dx-icon-overflow"></i>
</div>
);
}
export default TaskItem;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Position, TabsIconPosition, TabsStyle } from 'devextreme/common';
import type { Task } from './types.ts';
export const tabsPositionsSelectBoxLabel = { 'aria-label': 'Tab position' };
export const tabsPositions: Position[] = [
'left',
'top',
'right',
'bottom',
];
export const stylingModesSelectBoxLabel = { 'aria-label': 'Styling mode' };
export const stylingModes: TabsStyle[] = [
'secondary',
'primary',
];
export const iconPositionsSelectBoxLabel = { 'aria-label': 'Icon positions' };
export const iconPositions: TabsIconPosition[] = [
'top',
'start',
'end',
'bottom',
];
const tasks: Task[] = [
{
status: 'Not Started',
priority: 'high',
text: 'Revenue Projections',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Not Started',
priority: 'high',
text: 'New Brochures',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Not Started',
priority: 'medium',
text: 'Training',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Not Started',
priority: 'medium',
text: 'NDA',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Not Started',
priority: 'low',
text: 'Health Insurance',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Help Needed',
priority: 'low',
text: 'TV Recall',
date: '2023/09/16',
assignedBy: 'Brett Wade',
},
{
status: 'Help Needed',
priority: 'low',
text: 'Recall and Refund Forms',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Help Needed',
priority: 'high',
text: 'Shippers',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Help Needed',
priority: 'medium',
text: 'Hardware Upgrade',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Online Sales',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'In Progress',
priority: 'medium',
text: 'New Website Design',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'In Progress',
priority: 'low',
text: 'Bandwidth Increase',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Support',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'In Progress',
priority: 'low',
text: 'Training Material',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Deferred',
priority: 'medium',
text: 'New Database',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Deferred',
priority: 'high',
text: 'Automation Server',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Retail Sales',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Shipping Labels',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Rejected',
priority: 'high',
text: 'Schedule Meeting with Sales Team',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Confirm Availability for Sales Meeting',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Reschedule Sales Team Meeting',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'Rejected',
priority: 'high',
text: 'Update Database with New Leads',
date: '2023/09/16',
assignedBy: 'Kevin Carter',
},
{
status: 'Rejected',
priority: 'low',
text: 'Send Territory Sales Breakdown',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'Completed',
priority: 'medium',
text: 'Territory Sales Breakdown Report',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'Completed',
priority: 'low',
text: 'Return Merchandise Report',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'Completed',
priority: 'high',
text: 'Staff Productivity Report',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'Completed',
priority: 'medium',
text: 'Review HR Budget Company Wide',
date: '2023/09/16',
assignedBy: 'Mary Stern',
},
];
export const dataSource = [
{
icon: 'description',
title: 'Not Started',
tasks: tasks.filter((item) => item.status === 'Not Started'),
},
{
icon: 'taskhelpneeded',
title: 'Help Needed',
tasks: tasks.filter((item) => item.status === 'Help Needed'),
},
{
icon: 'taskinprogress',
title: 'In Progress',
tasks: tasks.filter((item) => item.status === 'In Progress'),
},
{
icon: 'taskstop',
title: 'Deferred',
tasks: tasks.filter((item) => item.status === 'Deferred'),
},
{
icon: 'taskrejected',
title: 'Rejected',
tasks: tasks.filter((item) => item.status === 'Rejected'),
},
{
icon: 'taskcomplete',
title: 'Completed',
tasks: tasks.filter((item) => item.status === 'Completed'),
},
];
export type Task = {
status: string;
priority: 'low' | 'medium' | 'high';
text: string;
date: string;
assignedBy: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import TaskItem from './TaskItem.js';
function TabPanelItem({ data }) {
const taskItems = data.tasks.map((task, index) => (
<TaskItem
key={index}
task={task}
/>
));
return <div className="tabpanel-item">{taskItems}</div>;
}
export default TabPanelItem;
import React from 'react';
function TaskItem({ task }) {
const {
priority, text, date, assignedBy,
} = task;
return (
<div className={`task-item task-item-priority-${priority}`}>
<span className="task-item-text">{text}</span>
<span className="task-item-info">{`${date} by ${assignedBy}`}</span>
<i className="task-item-pseudo-button dx-icon dx-icon-overflow"></i>
</div>
);
}
export default TaskItem;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const tabsPositionsSelectBoxLabel = { 'aria-label': 'Tab position' };
export const tabsPositions = ['left', 'top', 'right', 'bottom'];
export const stylingModesSelectBoxLabel = { 'aria-label': 'Styling mode' };
export const stylingModes = ['secondary', 'primary'];
export const iconPositionsSelectBoxLabel = { 'aria-label': 'Icon positions' };
export const iconPositions = ['top', 'start', 'end', 'bottom'];
const tasks = [
{
status: 'Not Started',
priority: 'high',
text: 'Revenue Projections',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Not Started',
priority: 'high',
text: 'New Brochures',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Not Started',
priority: 'medium',
text: 'Training',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Not Started',
priority: 'medium',
text: 'NDA',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Not Started',
priority: 'low',
text: 'Health Insurance',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Help Needed',
priority: 'low',
text: 'TV Recall',
date: '2023/09/16',
assignedBy: 'Brett Wade',
},
{
status: 'Help Needed',
priority: 'low',
text: 'Recall and Refund Forms',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Help Needed',
priority: 'high',
text: 'Shippers',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Help Needed',
priority: 'medium',
text: 'Hardware Upgrade',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Online Sales',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'In Progress',
priority: 'medium',
text: 'New Website Design',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'In Progress',
priority: 'low',
text: 'Bandwidth Increase',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'In Progress',
priority: 'medium',
text: 'Support',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'In Progress',
priority: 'low',
text: 'Training Material',
date: '2023/09/16',
assignedBy: 'John Heart',
},
{
status: 'Deferred',
priority: 'medium',
text: 'New Database',
date: '2023/09/16',
assignedBy: 'Samantha Bright',
},
{
status: 'Deferred',
priority: 'high',
text: 'Automation Server',
date: '2023/09/16',
assignedBy: 'Arthur Miller',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Retail Sales',
date: '2023/09/16',
assignedBy: 'Robert Reagan',
},
{
status: 'Deferred',
priority: 'medium',
text: 'Shipping Labels',
date: '2023/09/16',
assignedBy: 'Greta Sims',
},
{
status: 'Rejected',
priority: 'high',
text: 'Schedule Meeting with Sales Team',
date: '2023/09/16',
assignedBy: 'Sandra Johnson',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Confirm Availability for Sales Meeting',
date: '2023/09/16',
assignedBy: 'Ed Holmes',
},
{
status: 'Rejected',
priority: 'medium',
text: 'Reschedule Sales Team Meeting',
date: '2023/09/16',
assignedBy: 'Barb Banks',
},
{
status: 'Rejected',
priority: 'high',
text: 'Update Database with New Leads',
date: '2023/09/16',
assignedBy: 'Kevin Carter',
},
{
status: 'Rejected',
priority: 'low',
text: 'Send Territory Sales Breakdown',
date: '2023/09/16',
assignedBy: 'Cindy Stanwick',
},
{
status: 'Completed',
priority: 'medium',
text: 'Territory Sales Breakdown Report',
date: '2023/09/16',
assignedBy: 'Sammy Hill',
},
{
status: 'Completed',
priority: 'low',
text: 'Return Merchandise Report',
date: '2023/09/16',
assignedBy: 'Davey Jones',
},
{
status: 'Completed',
priority: 'high',
text: 'Staff Productivity Report',
date: '2023/09/16',
assignedBy: 'Victor Norris',
},
{
status: 'Completed',
priority: 'medium',
text: 'Review HR Budget Company Wide',
date: '2023/09/16',
assignedBy: 'Mary Stern',
},
];
export const dataSource = [
{
icon: 'description',
title: 'Not Started',
tasks: tasks.filter((item) => item.status === 'Not Started'),
},
{
icon: 'taskhelpneeded',
title: 'Help Needed',
tasks: tasks.filter((item) => item.status === 'Help Needed'),
},
{
icon: 'taskinprogress',
title: 'In Progress',
tasks: tasks.filter((item) => item.status === 'In Progress'),
},
{
icon: 'taskstop',
title: 'Deferred',
tasks: tasks.filter((item) => item.status === 'Deferred'),
},
{
icon: 'taskrejected',
title: 'Rejected',
tasks: tasks.filter((item) => item.status === 'Rejected'),
},
{
icon: 'taskcomplete',
title: 'Completed',
tasks: tasks.filter((item) => item.status === 'Completed'),
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.tabpanel-demo {
display: flex;
height: 100%;
}
.widget-container {
display: flex;
justify-content: center;
flex-grow: 1;
min-width: 360px;
padding: 16px 32px;
}
.tabpanel-demo .dx-tabpanel {
background-color: var(--dx-component-color-bg);
}
.dx-theme-material .widget-container {
background-color: rgba(191, 191, 191, 0.15);
}
.dx-tabpanel-tabs-position-left .dx-tabpanel-container,
.dx-tabpanel-tabs-position-right .dx-tabpanel-container {
width: 0;
}
.dx-viewport:not(.dx-theme-generic) .dx-tabpanel {
border-radius: 8px;
overflow: clip;
}
.dx-tabs-vertical {
min-width: 120px;
}
.options {
display: inline-flex;
flex-direction: column;
flex-shrink: 0;
box-sizing: border-box;
width: 272px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
margin-top: 20px;
}
.tabpanel-item {
display: flex;
flex-direction: column;
gap: 12px;
padding: 24px;
}
.task-item {
position: relative;
display: flex;
flex-direction: column;
justify-content: center;
width: 100%;
height: 50px;
padding: 8px 12px 8px 8px;
border-radius: 4px;
box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.15);
}
.task-item::before {
content: "";
position: absolute;
top: 8px;
left: 6px;
bottom: 8px;
width: 3px;
border-radius: 4px;
}
.task-item-priority-high::before {
background-color: #e1bee7;
}
.task-item-priority-medium::before {
background-color: #ffe0b2;
}
.task-item-priority-low::before {
background-color: #c8e6c9;
}
.task-item-text,
.task-item-info {
margin: 0;
padding: 0 24px 0 16px;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
}
.task-item-info {
font-size: 12px;
opacity: 0.6;
}
.task-item-pseudo-button {
position: absolute;
right: 8px;
top: 50%;
font-size: 18px;
transform: translateY(-50%);
cursor: pointer;
opacity: 0.6;
}
.dx-color-scheme-contrast .task-item {
border: 1px solid #fff;
}
.dx-theme-fluent.dx-color-scheme-blue-dark .task-item {
background-color: #1f1f1f;
}